diff --git a/gcc/config/alpha/vms.h b/gcc/config/alpha/vms.h
index df0130c..3ac03d1 100644
--- a/gcc/config/alpha/vms.h
+++ b/gcc/config/alpha/vms.h
@@ -48,7 +48,7 @@ along with GCC; see the file COPYING3.  If not see
 /* The maximum alignment 'malloc' honors.  */
 #undef  MALLOC_ABI_ALIGNMENT
 #define MALLOC_ABI_ALIGNMENT \
-  ((flag_vms_malloc64 && flag_vms_pointer_size != VMS_POINTER_SIZE_NONE	\
+  ((GCC_OPTION (flag_vms_malloc64) && GCC_OPTION (flag_vms_pointer_size) != VMS_POINTER_SIZE_NONE	\
    ? 16 : 8) * BITS_PER_UNIT)
 
 #undef FIXED_REGISTERS
@@ -154,7 +154,7 @@ typedef struct {int num_args; enum avms_arg_type atypes[6];} avms_arg_info;
 /* Even though pointers are 64bits, only 32bit ever remain significant in code
    addresses.  */
 #define MASK_RETURN_ADDR                                \
-  (flag_vms_pointer_size == VMS_POINTER_SIZE_NONE       \
+  (GCC_OPTION (flag_vms_pointer_size) == VMS_POINTER_SIZE_NONE       \
    ? constm1_rtx                                        \
    : GEN_INT (0xffffffff))
 
@@ -268,14 +268,14 @@ typedef struct {int num_args; enum avms_arg_type atypes[6];} avms_arg_info;
 #undef SUBTARGET_OVERRIDE_OPTIONS
 #define SUBTARGET_OVERRIDE_OPTIONS                  \
 do {                                                \
-  if (write_symbols == NO_DEBUG                     \
-      && debug_info_level == DINFO_LEVEL_NONE)      \
+  if (GCC_OPTION (write_symbols) == NO_DEBUG                     \
+      && GCC_OPTION (debug_info_level) == DINFO_LEVEL_NONE)      \
     {                                               \
-      write_symbols = VMS_DEBUG;                    \
-      debug_info_level = DINFO_LEVEL_TERSE;         \
+      GCC_OPTION (write_symbols) = VMS_DEBUG;                    \
+      GCC_OPTION (debug_info_level) = DINFO_LEVEL_TERSE;         \
     }                                               \
-  if (flag_pic)                                     \
-    flag_jump_tables = 0;                           \
+  if (GCC_OPTION (flag_pic))                                     \
+    GCC_OPTION (flag_jump_tables) = 0;                           \
 } while (0)
 
 #undef LINK_SPEC
diff --git a/gcc/config/arc/arc.c b/gcc/config/arc/arc.c
index 0eaabed..48e5648 100644
--- a/gcc/config/arc/arc.c
+++ b/gcc/config/arc/arc.c
@@ -93,7 +93,7 @@ static const char *arc_cpu_string = "";
  && ((GET_MODE_SIZE (MODE) == 2 && INTVAL (XEXP (XEXP (X, 0), 1)) == 2) \
      || (GET_MODE_SIZE (MODE) == 4 && INTVAL (XEXP (XEXP (X, 0), 1)) == 4)) \
  && (RTX_OK_FOR_BASE_P (XEXP (X, 1), (STRICT)) \
-     || (flag_pic ? CONST_INT_P (XEXP (X, 1)) : CONSTANT_P (XEXP (X, 1)))))
+     || (GCC_OPTION (flag_pic) ? CONST_INT_P (XEXP (X, 1)) : CONSTANT_P (XEXP (X, 1)))))
 
 #define LEGITIMATE_SMALL_DATA_ADDRESS_P(X) \
   (GET_CODE (X) == PLUS \
@@ -701,35 +701,35 @@ arc_init (void)
     }
   else
     gcc_unreachable ();
-  if (arc_tune == TUNE_NONE)
-    arc_tune = tune_dflt;
+  if (GCC_OPTION (arc_tune) == TUNE_NONE)
+    GCC_OPTION (arc_tune) = tune_dflt;
   /* Note: arc_multcost is only used in rtx_cost if speed is true.  */
-  if (arc_multcost < 0)
-    switch (arc_tune)
+  if (GCC_OPTION (arc_multcost) < 0)
+    switch (GCC_OPTION (arc_tune))
       {
       case TUNE_ARC700_4_2_STD:
 	/* latency 7;
 	   max throughput (1 multiply + 4 other insns) / 5 cycles.  */
-	arc_multcost = COSTS_N_INSNS (4);
+	GCC_OPTION (arc_multcost) = COSTS_N_INSNS (4);
 	if (TARGET_NOMPY_SET)
-	  arc_multcost = COSTS_N_INSNS (30);
+	  GCC_OPTION (arc_multcost) = COSTS_N_INSNS (30);
 	break;
       case TUNE_ARC700_4_2_XMAC:
 	/* latency 5;
 	   max throughput (1 multiply + 2 other insns) / 3 cycles.  */
-	arc_multcost = COSTS_N_INSNS (3);
+	GCC_OPTION (arc_multcost) = COSTS_N_INSNS (3);
 	if (TARGET_NOMPY_SET)
-	  arc_multcost = COSTS_N_INSNS (30);
+	  GCC_OPTION (arc_multcost) = COSTS_N_INSNS (30);
 	break;
       case TUNE_ARC600:
 	if (TARGET_MUL64_SET)
 	  {
-	    arc_multcost = COSTS_N_INSNS (4);
+	    GCC_OPTION (arc_multcost) = COSTS_N_INSNS (4);
 	    break;
 	  }
 	/* Fall through.  */
       default:
-	arc_multcost = COSTS_N_INSNS (30);
+	GCC_OPTION (arc_multcost) = COSTS_N_INSNS (30);
 	break;
       }
 
@@ -763,10 +763,10 @@ arc_init (void)
     error ("FPX extensions not available on pre-ARC600 cores");
 
   /* Warn for unimplemented PIC in pre-ARC700 cores, and disable flag_pic.  */
-  if (flag_pic && !TARGET_ARC700)
+  if (GCC_OPTION (flag_pic) && !TARGET_ARC700)
     {
       warning (DK_WARNING, "PIC is not supported for %s. Generating non-PIC code only..", arc_cpu_string);
-      flag_pic = 0;
+      GCC_OPTION (flag_pic) = 0;
     }
 
   arc_init_reg_tables ();
@@ -780,7 +780,7 @@ arc_init (void)
   arc_punct_chars['^'] = 1;
   arc_punct_chars['&'] = 1;
 
-  if (optimize > 1 && !TARGET_NO_COND_EXEC)
+  if (GCC_OPTION (optimize) > 1 && !TARGET_NO_COND_EXEC)
     {
       /* There are two target-independent ifcvt passes, and arc_reorg may do
 	 one or more arc_ifcvt calls.  */
@@ -794,7 +794,7 @@ arc_init (void)
       register_pass (&arc_ifcvt5_info);
     }
 
-  if (flag_delayed_branch)
+  if (GCC_OPTION (flag_delayed_branch))
     {
       opt_pass *pass_arc_predicate_delay_insns
 	= make_pass_arc_predicate_delay_insns (g);
@@ -810,25 +810,25 @@ arc_init (void)
 static void
 arc_override_options (void)
 {
-  if (arc_cpu == PROCESSOR_NONE)
-    arc_cpu = PROCESSOR_ARC700;
+  if (GCC_OPTION (arc_cpu) == PROCESSOR_NONE)
+    GCC_OPTION (arc_cpu) = PROCESSOR_ARC700;
 
-  if (arc_size_opt_level == 3)
-    optimize_size = 1;
+  if (GCC_OPTION (arc_size_opt_level) == 3)
+    GCC_OPTION (optimize_size) = 1;
 
-  if (flag_pic)
-    target_flags |= MASK_NO_SDATA_SET;
+  if (GCC_OPTION (flag_pic))
+    GCC_OPTION (target_flags) |= MASK_NO_SDATA_SET;
 
-  if (flag_no_common == 255)
-    flag_no_common = !TARGET_NO_SDATA_SET;
+  if (GCC_OPTION (flag_no_common) == 255)
+    GCC_OPTION (flag_no_common) = !TARGET_NO_SDATA_SET;
 
   /* TARGET_COMPACT_CASESI needs the "q" register class.  */ \
   if (TARGET_MIXED_CODE)
-    TARGET_Q_CLASS = 1;
-  if (!TARGET_Q_CLASS)
-    TARGET_COMPACT_CASESI = 0;
-  if (TARGET_COMPACT_CASESI)
-    TARGET_CASE_VECTOR_PC_RELATIVE = 1;
+    GCC_OPTION (TARGET_Q_CLASS) = 1;
+  if (!GCC_OPTION (TARGET_Q_CLASS))
+    GCC_OPTION (TARGET_COMPACT_CASESI) = 0;
+  if (GCC_OPTION (TARGET_COMPACT_CASESI))
+    GCC_OPTION (TARGET_CASE_VECTOR_PC_RELATIVE) = 1;
 
   /* These need to be done at start up.  It's convenient to do them here.  */
   arc_init ();
@@ -1230,7 +1230,7 @@ arc_conditional_register_usage (void)
 	warning (0, "multiply option implies r%d is fixed", regno);
       fixed_regs [regno] = call_used_regs[regno] = 1;
     }
-  if (TARGET_Q_CLASS)
+  if (GCC_OPTION (TARGET_Q_CLASS))
     {
       reg_alloc_order[2] = 12;
       reg_alloc_order[3] = 13;
@@ -1298,7 +1298,7 @@ arc_conditional_register_usage (void)
     {
       if (i < 29)
 	{
-	  if (TARGET_Q_CLASS && ((i <= 3) || ((i >= 12) && (i <= 15))))
+	  if (GCC_OPTION (TARGET_Q_CLASS) && ((i <= 3) || ((i >= 12) && (i <= 15))))
 	    arc_regno_reg_class[i] = ARCOMPACT16_REGS;
 	  else
 	    arc_regno_reg_class[i] = GENERAL_REGS;
@@ -1316,7 +1316,7 @@ arc_conditional_register_usage (void)
     }
 
   /* ARCOMPACT16_REGS is empty, if TARGET_Q_CLASS has not been activated.  */
-  if (!TARGET_Q_CLASS)
+  if (!GCC_OPTION (TARGET_Q_CLASS))
     {
       CLEAR_HARD_REG_SET(reg_class_contents [ARCOMPACT16_REGS]);
       CLEAR_HARD_REG_SET(reg_class_contents [AC16_BASE_REGS]);
@@ -1497,7 +1497,7 @@ gen_compare_reg (rtx comparison, enum machine_mode omode)
 	  else
 	    x = copy_to_mode_reg (SImode, x);
 	}
-      if (GET_CODE (y) == SYMBOL_REF && flag_pic)
+      if (GET_CODE (y) == SYMBOL_REF && GCC_OPTION (flag_pic))
 	y = copy_to_mode_reg (SImode, y);
     }
   else
@@ -1954,7 +1954,7 @@ arc_compute_function_type (struct function *fun)
 #define MUST_SAVE_REGISTER(regno, interrupt_p) \
 (((regno) != RETURN_ADDR_REGNUM && (regno) != FRAME_POINTER_REGNUM \
   && (df_regs_ever_live_p (regno) && (!call_used_regs[regno] || interrupt_p))) \
- || (flag_pic && crtl->uses_pic_offset_table \
+ || (GCC_OPTION (flag_pic) && crtl->uses_pic_offset_table \
      && regno == PIC_OFFSET_TABLE_REGNUM) )
 
 #define MUST_SAVE_RETURN_ADDR \
@@ -2039,7 +2039,7 @@ arc_compute_frame_size (int size)	/* size = # of var. bytes allocated.  */
   frame_info->save_return_addr
     = (!crtl->is_leaf || df_regs_ever_live_p (RETURN_ADDR_REGNUM));
   /* Saving blink reg in case of leaf function for millicode thunk calls.  */
-  if (optimize_size && !TARGET_NO_MILLICODE_THUNK_SET)
+  if (GCC_OPTION (optimize_size) && !TARGET_NO_MILLICODE_THUNK_SET)
     {
       if (arc_compute_millicode_save_restore_regs (gmask, frame_info))
 	frame_info->save_return_addr = true;
@@ -2228,7 +2228,7 @@ arc_expand_prologue (void)
 	   ? arc_compute_frame_size (size)
 	   : cfun->machine->frame_info.total_size);
 
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     current_function_static_stack_size = size;
 
   /* Keep track of frame size to be allocated.  */
@@ -2379,7 +2379,7 @@ arc_expand_epilogue (int sibcall_p)
      fast add to the stack pointer, do this now.  */
   if ((!SMALL_INT (first_offset)
        && cfun->machine->frame_info.gmask
-       && ((TARGET_ARC700 && !optimize_size)
+       && ((TARGET_ARC700 && !GCC_OPTION (optimize_size))
 	    ? first_offset <= 0x800
 	    : satisfies_constraint_C2a (GEN_INT (first_offset))))
        /* Also do this if we have both gprs and return
@@ -2401,7 +2401,7 @@ arc_expand_epilogue (int sibcall_p)
 	 the offset quickly to sp, do the latter.  */
       if (!SMALL_INT (ra_offs >> 2)
 	  && !cfun->machine->frame_info.gmask
-	  && ((TARGET_ARC700 && !optimize_size)
+	  && ((TARGET_ARC700 && !GCC_OPTION (optimize_size))
 	       ? ra_offs <= 0x800
 	       : satisfies_constraint_C2a (GEN_INT (ra_offs))))
 	{
@@ -2502,7 +2502,7 @@ arc_finalize_pic (void)
   if (crtl->uses_pic_offset_table == 0)
     return;
 
-  gcc_assert (flag_pic != 0);
+  gcc_assert (GCC_OPTION (flag_pic) != 0);
 
   pat = gen_rtx_SYMBOL_REF (Pmode, "_DYNAMIC");
   pat = gen_rtx_UNSPEC (Pmode, gen_rtvec (1, pat), ARC_UNSPEC_GOT);
@@ -3105,7 +3105,7 @@ arc_print_operand (FILE *file, rtx x, int code)
 	}
       break;
     case '&':
-      if (TARGET_ANNOTATE_ALIGN && cfun->machine->size_reason)
+      if (GCC_OPTION (TARGET_ANNOTATE_ALIGN) && cfun->machine->size_reason)
 	fprintf (file, "; unalign: %d", cfun->machine->unalign);
       return;
     default :
@@ -3146,7 +3146,7 @@ arc_print_operand (FILE *file, rtx x, int code)
 	      output_address (addr);
 	    break;
 	  default:
-	    if (flag_pic && CONSTANT_ADDRESS_P (addr))
+	    if (GCC_OPTION (flag_pic) && CONSTANT_ADDRESS_P (addr))
 	      arc_output_pic_addr_const (file, addr, code);
 	    else
 	      output_address (addr);
@@ -3169,7 +3169,7 @@ arc_print_operand (FILE *file, rtx x, int code)
 	}
       /* Fall through.  Let output_addr_const deal with it.  */
     default :
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	arc_output_pic_addr_const (file, x, code);
       else
 	{
@@ -3248,7 +3248,7 @@ arc_print_operand_address (FILE *file , rtx addr)
       gcc_unreachable ();
       break;
     default :
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	arc_output_pic_addr_const (file, addr, 0);
       else
 	output_addr_const (file, addr);
@@ -3422,7 +3422,7 @@ arc_ccfsm_advance (rtx insn, struct arc_ccfsm *state)
   /* Allow -mdebug-ccfsm to turn this off so we can see how well it does.
      We can't do this in macro FINAL_PRESCAN_INSN because its called from
      final_scan_insn which has `optimize' as a local.  */
-  if (optimize < 2 || TARGET_NO_COND_EXEC)
+  if (GCC_OPTION (optimize) < 2 || TARGET_NO_COND_EXEC)
     return;
 
   /* Ignore notes and labels.  */
@@ -3923,7 +3923,7 @@ void
 arc_final_prescan_insn (rtx insn, rtx *opvec ATTRIBUTE_UNUSED,
 			int noperands ATTRIBUTE_UNUSED)
 {
-  if (TARGET_DUMPISIZE)
+  if (GCC_OPTION (TARGET_DUMPISIZE))
     fprintf (asm_out_file, "\n; at %04x\n", INSN_ADDRESSES (INSN_UID (insn)));
 
   /* Output a nop if necessary to prevent a hazard.
@@ -3937,7 +3937,7 @@ arc_final_prescan_insn (rtx insn, rtx *opvec ATTRIBUTE_UNUSED,
     {
       current_output_insn =
 	emit_insn_before (gen_nop (), NEXT_INSN (PREV_INSN (insn)));
-      final_scan_insn (current_output_insn, asm_out_file, optimize, 1, NULL);
+      final_scan_insn (current_output_insn, asm_out_file, GCC_OPTION (optimize), 1, NULL);
       current_output_insn = insn;
     }
   /* Restore extraction data which might have been clobbered by arc_hazard.  */
@@ -4209,7 +4209,7 @@ arc_rtx_costs (rtx x, int code, int outer_code, int opno ATTRIBUTE_UNUSED,
       if ((TARGET_DPFP && GET_MODE (x) == DFmode))
 	*total = COSTS_N_INSNS (1);
       else if (speed)
-	*total= arc_multcost;
+	*total= GCC_OPTION (arc_multcost);
       /* We do not want synth_mult sequences when optimizing
 	 for size.  */
       else if (TARGET_MUL64_SET || (TARGET_ARC700 && !TARGET_NOMPY_SET))
@@ -4560,7 +4560,7 @@ arc_output_pic_addr_const (FILE * file, rtx x, int code)
   switch (GET_CODE (x))
     {
     case PC:
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	putc ('.', file);
       else
 	gcc_unreachable ();
@@ -4900,7 +4900,7 @@ arc_legitimate_pic_operand_p (rtx x)
 bool
 arc_legitimate_constant_p (enum machine_mode, rtx x)
 {
-  if (!flag_pic)
+  if (!GCC_OPTION (flag_pic))
     return true;
 
   switch (GET_CODE (x))
@@ -4953,7 +4953,7 @@ arc_legitimate_address_p (enum machine_mode mode, rtx x, bool strict)
 {
   if (RTX_OK_FOR_BASE_P (x, strict))
      return true;
-  if (LEGITIMATE_OFFSET_ADDRESS_P (mode, x, TARGET_INDEXED_LOADS, strict))
+  if (LEGITIMATE_OFFSET_ADDRESS_P (mode, x, GCC_OPTION (TARGET_INDEXED_LOADS), strict))
      return true;
   if (LEGITIMATE_SCALED_ADDRESS_P (mode, x, strict))
     return true;
@@ -4966,7 +4966,7 @@ arc_legitimate_address_p (enum machine_mode mode, rtx x, bool strict)
 	  || GET_CODE (x) == LABEL_REF
 	  || GET_CODE (x) == CONST))
     {
-      if (!flag_pic || arc_legitimate_pic_addr_p (x))
+      if (!GCC_OPTION (flag_pic) || arc_legitimate_pic_addr_p (x))
 	return true;
     }
   if ((GET_CODE (x) == PRE_DEC || GET_CODE (x) == PRE_INC
@@ -4978,7 +4978,7 @@ arc_legitimate_address_p (enum machine_mode mode, rtx x, bool strict)
       && GET_CODE (XEXP ((x), 1)) == PLUS
       && rtx_equal_p (XEXP ((x), 0), XEXP (XEXP (x, 1), 0))
       && LEGITIMATE_OFFSET_ADDRESS_P (QImode, XEXP (x, 1),
-				      TARGET_AUTO_MODIFY_REG, strict))
+				      GCC_OPTION (TARGET_AUTO_MODIFY_REG), strict))
     return true;
   return false;
 }
@@ -5369,7 +5369,7 @@ arc_expand_builtin (tree exp,
 	{
 	  /* If we can't fold the alignment to a constant integer
 	     whilst optimizing, this is probably a user error.  */
-	  if (optimize)
+	  if (GCC_OPTION (optimize))
 	    warning (0, "__builtin_arc_aligned with non-constant alignment");
 	}
       else
@@ -5566,7 +5566,7 @@ arc_is_shortcall_p (rtx sym_ref)
     return false;
 
   return (SYMBOL_REF_SHORT_CALL_P (sym_ref)
-	  || (!TARGET_LONG_CALLS_SET && !TARGET_MEDIUM_CALLS
+	  || (!TARGET_LONG_CALLS_SET && !GCC_OPTION (TARGET_MEDIUM_CALLS)
 	      && !SYMBOL_REF_LONG_CALL_P (sym_ref)
 	      && !SYMBOL_REF_MEDIUM_CALL_P (sym_ref)));
 
@@ -5580,7 +5580,7 @@ arc_profile_call (rtx callee)
 {
   rtx from = XEXP (DECL_RTL (current_function_decl), 0);
 
-  if (TARGET_UCB_MCOUNT)
+  if (GCC_OPTION (TARGET_UCB_MCOUNT))
     /* Profiling is done by instrumenting the callee.  */
     return false;
 
@@ -5706,7 +5706,7 @@ arc_can_use_doloop_p (double_int iterations, double_int,
       && !entered_at_top
       && iterations.high == 0
       && iterations.low > 0
-      && iterations.low <= (flag_pic ? 6 : 3))
+      && iterations.low <= (GCC_OPTION (flag_pic) ? 6 : 3))
     return false;
   return true;
 }
@@ -5988,7 +5988,7 @@ arc_reorg (void)
       init_insn_lengths();
       changed = 0;
 
-      if (optimize > 1 && !TARGET_NO_COND_EXEC)
+      if (GCC_OPTION (optimize) > 1 && !TARGET_NO_COND_EXEC)
 	{
 	  arc_ifcvt ();
 	  unsigned int flags = pass_data_arc_ifcvt.todo_flags_finish;
@@ -6222,7 +6222,7 @@ arc_reorg (void)
 bool
 valid_brcc_with_delay_p (rtx *operands)
 {
-  if (optimize_size && GET_MODE (operands[4]) == CC_Zmode)
+  if (GCC_OPTION (optimize_size) && GET_MODE (operands[4]) == CC_Zmode)
     return false;
   return brcc_nolimm_operator (operands[0], VOIDmode);
 }
@@ -7511,7 +7511,7 @@ arc_expand_movmem (rtx *operands)
     n_pieces = (size + 1) / 2U;
   else
     n_pieces = size;
-  if (n_pieces >= (unsigned int) (optimize_size ? 3 : 15))
+  if (n_pieces >= (unsigned int) (GCC_OPTION (optimize_size) ? 3 : 15))
     return false;
   if (piece > 4)
     piece = 4;
@@ -7561,7 +7561,7 @@ prepare_move_operands (rtx *operands, enum machine_mode mode)
     {
       if (!TARGET_NO_SDATA_SET && small_data_pattern (operands[0], Pmode))
 	operands[0] = arc_rewrite_small_data (operands[0]);
-      else if (mode == SImode && flag_pic && SYMBOLIC_CONST (operands[1]))
+      else if (mode == SImode && GCC_OPTION (flag_pic) && SYMBOLIC_CONST (operands[1]))
 	{
 	  emit_pic_move (operands, SImode);
 
@@ -7672,9 +7672,9 @@ arc_output_libcall (const char *fname)
 
   gcc_assert (len < sizeof buf - 35);
   if (TARGET_LONG_CALLS_SET
-     || (TARGET_MEDIUM_CALLS && arc_ccfsm_cond_exec_p ()))
+     || (GCC_OPTION (TARGET_MEDIUM_CALLS) && arc_ccfsm_cond_exec_p ()))
     {
-      if (flag_pic)
+      if (GCC_OPTION (flag_pic))
 	sprintf (buf, "add r12,pcl,@%s-(.&-4)\n\tjl%%!%%* [r12]", fname);
       else
 	sprintf (buf, "jl%%! @%s", fname);
@@ -7897,7 +7897,7 @@ arc_get_insn_variants (rtx insn, int len, bool, bool target_p,
   enum attr_type type;
   /* shorten_branches doesn't take optimize_size into account yet for the
      get_variants mechanism, so turn this off for now.  */
-  if (optimize_size)
+  if (GCC_OPTION (optimize_size))
     return 0;
   if (GET_CODE (PATTERN (insn)) == SEQUENCE)
     {
@@ -8462,7 +8462,7 @@ arc_legitimize_address_0 (rtx x, rtx oldx ATTRIBUTE_UNUSED,
 {
   rtx addr, inner;
 
-  if (flag_pic && SYMBOLIC_CONST (x))
+  if (GCC_OPTION (flag_pic) && SYMBOLIC_CONST (x))
      (x) =  arc_legitimize_pic_address (x, 0);
   addr = x;
   if (GET_CODE (addr) == CONST)
@@ -8619,8 +8619,8 @@ arc_unalign_branch_p (rtx branch)
     return 0;
   note = find_reg_note (branch, REG_BR_PROB, 0);
   return (!note
-	  || (arc_unalign_prob_threshold && !br_prob_note_reliable_p (note))
-	  || INTVAL (XEXP (note, 0)) < arc_unalign_prob_threshold);
+	  || (GCC_OPTION (arc_unalign_prob_threshold) && !br_prob_note_reliable_p (note))
+	  || INTVAL (XEXP (note, 0)) < GCC_OPTION (arc_unalign_prob_threshold));
 }
 #endif
 
@@ -8636,7 +8636,7 @@ arc_unalign_branch_p (rtx branch)
 bool
 arc_branch_size_unknown_p (void)
 {
-  return !optimize_size && arc_reorg_in_progress;
+  return !GCC_OPTION (optimize_size) && arc_reorg_in_progress;
 }
 
 /* We are about to output a return insn.  Add padding if necessary to avoid
@@ -8694,7 +8694,7 @@ arc_pad_return (void)
 		      || !arc_hazard (prev_real_insn (insn), prev));
 	  cfun->machine->force_short_suffix = !want_long;
 	  rtx save_pred = current_insn_predicate;
-	  final_scan_insn (prev, asm_out_file, optimize, 1, NULL);
+	  final_scan_insn (prev, asm_out_file, GCC_OPTION (optimize), 1, NULL);
 	  cfun->machine->force_short_suffix = -1;
 	  INSN_DELETED_P (prev) = 1;
 	  current_output_insn = insn;
@@ -9099,7 +9099,7 @@ arc_need_delay (rtx insn)
 {
   rtx next;
 
-  if (!flag_delayed_branch)
+  if (!GCC_OPTION (flag_delayed_branch))
     return false;
   /* The return at the end of a function needs a delay slot.  */
   if (NONJUMP_INSN_P (insn) && GET_CODE (PATTERN (insn)) == USE
@@ -9268,7 +9268,7 @@ arc_lra_p (void)
 static int
 arc_register_priority (int r)
 {
-  switch (arc_lra_priority_tag)
+  switch (GCC_OPTION (arc_lra_priority_tag))
     {
     case ARC_LRA_PRIORITY_NONE:
       return 0;
diff --git a/gcc/config/arc/arc.h b/gcc/config/arc/arc.h
index 8c7350f..c09b6f3 100644
--- a/gcc/config/arc/arc.h
+++ b/gcc/config/arc/arc.h
@@ -265,22 +265,22 @@ along with GCC; see the file COPYING3.  If not see
    that we can pick & choose features if we get a new cpu family member.  */
 
 /* Should we try to unalign likely taken branches without a delay slot.  */
-#define TARGET_UNALIGN_BRANCH (TARGET_ARC700 && !optimize_size)
+#define TARGET_UNALIGN_BRANCH (TARGET_ARC700 && !GCC_OPTION (optimize_size))
 
 /* Should we upsize short delayed branches with a short delay insn?  */
-#define TARGET_UPSIZE_DBR (TARGET_ARC700 && !optimize_size)
+#define TARGET_UPSIZE_DBR (TARGET_ARC700 && !GCC_OPTION (optimize_size))
 
 /* Should we add padding before a return insn to avoid mispredict?  */
-#define TARGET_PAD_RETURN (TARGET_ARC700 && !optimize_size)
+#define TARGET_PAD_RETURN (TARGET_ARC700 && !GCC_OPTION (optimize_size))
 
 /* For an anulled-true delay slot insn for a delayed branch, should we only
    use conditional execution?  */
 #define TARGET_AT_DBR_CONDEXEC  (!TARGET_ARC700)
 
-#define TARGET_A5 (arc_cpu == PROCESSOR_A5)
-#define TARGET_ARC600 (arc_cpu == PROCESSOR_ARC600)
-#define TARGET_ARC601 (arc_cpu == PROCESSOR_ARC601)
-#define TARGET_ARC700 (arc_cpu == PROCESSOR_ARC700)
+#define TARGET_A5 (GCC_OPTION (arc_cpu) == PROCESSOR_A5)
+#define TARGET_ARC600 (GCC_OPTION (arc_cpu) == PROCESSOR_ARC600)
+#define TARGET_ARC601 (GCC_OPTION (arc_cpu) == PROCESSOR_ARC601)
+#define TARGET_ARC700 (GCC_OPTION (arc_cpu) == PROCESSOR_ARC700)
 
 /* Recast the cpu class to be the cpu attribute.  */
 #define arc_cpu_attr ((enum attr_cpu)arc_cpu)
@@ -391,7 +391,7 @@ if (GET_MODE_CLASS (MODE) == MODE_INT		\
 #define DATA_ALIGNMENT(TYPE, ALIGN)		\
   (TREE_CODE (TYPE) == ARRAY_TYPE		\
    && TYPE_MODE (TREE_TYPE (TYPE)) == QImode	\
-   && arc_size_opt_level < 3			\
+   && GCC_OPTION (arc_size_opt_level) < 3			\
    && (ALIGN) < FASTEST_ALIGNMENT ? FASTEST_ALIGNMENT : (ALIGN))
 
 /* Set this nonzero if move instructions will actually fail to work
@@ -942,7 +942,7 @@ extern int arc_initial_elimination_offset(int from, int to);
    We actually emit the profiler code at the call site, so leave this one
    empty.  */
 #define FUNCTION_PROFILER(FILE, LABELNO) \
-  if (TARGET_UCB_MCOUNT) \
+  if (GCC_OPTION (TARGET_UCB_MCOUNT)) \
     fprintf (FILE, "\t%s\n", arc_output_libcall ("__mcount"))
 
 #define NO_PROFILE_COUNTERS  1
@@ -980,7 +980,7 @@ extern int arc_initial_elimination_offset(int from, int to);
 
 /* Recognize any constant value that is a valid address.  */
 #define CONSTANT_ADDRESS_P(X) \
-(flag_pic?arc_legitimate_pic_addr_p (X): \
+(GCC_OPTION (flag_pic)?arc_legitimate_pic_addr_p (X): \
 (GET_CODE (X) == LABEL_REF || GET_CODE (X) == SYMBOL_REF	\
  || GET_CODE (X) == CONST_INT || GET_CODE (X) == CONST))
 
@@ -1130,7 +1130,7 @@ arc_select_cc_mode (OP, X, Y)
    output in the text section, along with the assembler instructions.
    Otherwise, the readonly data section is used.
    This macro is irrelevant if there is no separate readonly data section.  */
-#define JUMP_TABLES_IN_TEXT_SECTION  (flag_pic || CASE_VECTOR_PC_RELATIVE)
+#define JUMP_TABLES_IN_TEXT_SECTION  (GCC_OPTION (flag_pic) || CASE_VECTOR_PC_RELATIVE)
 
 /* For DWARF.  Marginally different than default so output is "prettier"
    (and consistent with above).  */
@@ -1169,7 +1169,7 @@ arc_select_cc_mode (OP, X, Y)
 #define SDATA_BASE_REGNUM 26
 
 #define ASM_PREFERRED_EH_DATA_FORMAT(CODE, GLOBAL) \
-  (flag_pic \
+  (GCC_OPTION (flag_pic) \
    ? (GLOBAL ? DW_EH_PE_indirect : 0) | DW_EH_PE_pcrel | DW_EH_PE_sdata4 \
    : DW_EH_PE_absptr)
 
@@ -1392,7 +1392,7 @@ do {							\
   fprintf (FILE, "-");					\
   ASM_GENERATE_INTERNAL_LABEL (label, "L", REL);	\
   assemble_name (FILE, label);				\
-  if (TARGET_COMPACT_CASESI)				\
+  if (GCC_OPTION (TARGET_COMPACT_CASESI))				\
     fprintf (FILE, " + %d", 4 + arc_get_unalign ());	\
   fprintf(FILE, "\n");                                  \
 } while (0)
@@ -1410,7 +1410,7 @@ do {							\
     }                                                   \
   while (0)
 
-#define JUMP_ALIGN(LABEL) (arc_size_opt_level < 2 ? 2 : 0)
+#define JUMP_ALIGN(LABEL) (GCC_OPTION (arc_size_opt_level) < 2 ? 2 : 0)
 #define LABEL_ALIGN_AFTER_BARRIER(LABEL) \
   (JUMP_ALIGN(LABEL) \
    ? JUMP_ALIGN(LABEL) \
@@ -1503,17 +1503,17 @@ extern int arc_return_address_regs[4];
    If we have pc relative case vectors, we start the case vector shortening
    with QImode.  */
 #define CASE_VECTOR_MODE \
-  ((optimize && (CASE_VECTOR_PC_RELATIVE || flag_pic)) ? QImode : Pmode)
+  ((GCC_OPTION (optimize) && (CASE_VECTOR_PC_RELATIVE || GCC_OPTION (flag_pic))) ? QImode : Pmode)
 
 /* Define as C expression which evaluates to nonzero if the tablejump
    instruction expects the table to contain offsets from the address of the
    table.
    Do not define this if the table should contain absolute addresses.  */
-#define CASE_VECTOR_PC_RELATIVE TARGET_CASE_VECTOR_PC_RELATIVE
+#define CASE_VECTOR_PC_RELATIVE GCC_OPTION (TARGET_CASE_VECTOR_PC_RELATIVE)
 
 #define CASE_VECTOR_SHORTEN_MODE(MIN_OFFSET, MAX_OFFSET, BODY) \
   CASE_VECTOR_SHORTEN_MODE_1 \
-    (MIN_OFFSET, TARGET_COMPACT_CASESI ? MAX_OFFSET + 6 : MAX_OFFSET, BODY)
+    (MIN_OFFSET, GCC_OPTION (TARGET_COMPACT_CASESI) ? MAX_OFFSET + 6 : MAX_OFFSET, BODY)
 
 #define CASE_VECTOR_SHORTEN_MODE_1(MIN_OFFSET, MAX_OFFSET, BODY) \
 ((MIN_OFFSET) >= 0 && (MAX_OFFSET) <= 255 \
@@ -1557,7 +1557,7 @@ extern int arc_return_address_regs[4];
 #define MOVE_BY_PIECES_P(LEN, ALIGN)  0
 #define CAN_MOVE_BY_PIECES(SIZE, ALIGN) \
   (move_by_pieces_ninsns (SIZE, ALIGN, MOVE_MAX_PIECES + 1) \
-   < (unsigned int) MOVE_RATIO (!optimize_size))
+   < (unsigned int) MOVE_RATIO (!GCC_OPTION (optimize_size)))
 
 /* Undo the effects of the movmem pattern presence on STORE_BY_PIECES_P .  */
 #define MOVE_RATIO(SPEED) ((SPEED) ? 15 : 3)
@@ -1691,6 +1691,6 @@ enum
    the pattern condition of all sfunc patterns which is only relevant for
    the predicated varaint.  */
 #define SFUNC_CHECK_PREDICABLE \
-  (GET_CODE (PATTERN (insn)) != COND_EXEC || !flag_pic || !TARGET_MEDIUM_CALLS)
+  (GET_CODE (PATTERN (insn)) != COND_EXEC || !GCC_OPTION (flag_pic) || !GCC_OPTION (TARGET_MEDIUM_CALLS))
 
 #endif /* GCC_ARC_H */
diff --git a/gcc/config/arm/aout.h b/gcc/config/arm/aout.h
index 51d32a9..4a599e2 100644
--- a/gcc/config/arm/aout.h
+++ b/gcc/config/arm/aout.h
@@ -187,7 +187,7 @@
 	asm_fprintf (STREAM, "\tb\t%LL%d\n", VALUE);			\
       else if (TARGET_THUMB1)						\
 	{								\
-	  if (flag_pic || optimize_size)				\
+	  if (GCC_OPTION (flag_pic) || GCC_OPTION (optimize_size))				\
 	    {								\
 	      switch (GET_MODE(body))					\
 		{							\
@@ -223,7 +223,7 @@
 			   VALUE, REL);					\
 	      break;							\
 	    case SImode:						\
-	      if (flag_pic)						\
+	      if (GCC_OPTION (flag_pic))						\
 		asm_fprintf (STREAM, "\t.word\t%LL%d+1-%LL%d\n", VALUE, REL); \
 	      else							\
 		asm_fprintf (STREAM, "\t.word\t%LL%d+1\n", VALUE);	\
diff --git a/gcc/config/arm/arm-modes.def b/gcc/config/arm/arm-modes.def
index 882aa55..b18266e 100644
--- a/gcc/config/arm/arm-modes.def
+++ b/gcc/config/arm/arm-modes.def
@@ -27,7 +27,7 @@ FLOAT_MODE (XF, 12, 0);
 
 /* Half-precision floating point */
 FLOAT_MODE (HF, 2, 0);
-ADJUST_FLOAT_FORMAT (HF, ((arm_fp16_format == ARM_FP16_FORMAT_ALTERNATIVE)
+ADJUST_FLOAT_FORMAT (HF, ((GCC_OPTION (arm_fp16_format) == ARM_FP16_FORMAT_ALTERNATIVE)
 			  ? &arm_half_format : &ieee_half_format));
 
 /* CCFPEmode should be used with floating inequalities,
